﻿   
   /* ********************************************************************
    * Onload function
    * ********************************************************************
    */
    function RSF_SingleConfLoad(event)
    {
      try{
          var ds = window.arguments[0];
          var m_tree = document.getElementById('4');
          var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                           getService(Components.interfaces.nsIRDFService);
          var m_pre = 'http://realso.cn/rdf#IsRoot';
          var m_obj = 'true';
          var m_resPre = rdfService.GetResource(m_pre);
          var m_resObj = rdfService.GetLiteral(m_obj);
          var subjects = ds.GetSources( m_resPre , m_resObj , true);    
           
          while(subjects.hasMoreElements( ))
          {  
            var m_rdfResource = subjects.getNext();
            
            m_rdfResource.QueryInterface(Components.interfaces.nsIRDFResource);
            m_tree.ref  = m_rdfResource.Value;
          }
          
          var m_fieldMenulist = document.getElementById('14');
          var tds = m_tree.database.GetDataSources();
          
            while (tds.hasMoreElements())
            {
                m_tree.database.RemoveDataSource(tds.getNext());
            }
            m_tree.database.AddDataSource(ds);
            m_tree.builder.rebuild();
            
            m_fieldMenulist.database.AddDataSource(ds);
          
          var m_obj = window.arguments[1].target;
          var m_checkBox = document.getElementById('60');
          if(m_obj.hasAttribute('RS_datasource'))
          {
            m_checkBox.checked = true;
            document.getElementById('41').value = m_obj.getAttribute('RS_datasource');
            document.getElementById('14').setAttribute('label',m_obj.getAttribute('RS_field'));
          }
            else
            {
                m_checkBox.checked = false;
            }
          
      }catch(e){
         alert('BindConfig2.js RSF_SingleConfLoad() '+e);
         throw e;
      }
    }
    
   /* ********************************************************************
    * Function of tree select event. By this select function, we may
    * get datasource path and table field, or only datasource path if
    * select a subschema table.
    * ********************************************************************
    */
     function RSF_dsSel(event)
     {
      try{
            var m_selInd = event.target.view.selection.currentIndex;
            var m_l = event.target.view.getLevel(m_selInd);
            var m_dsPath = RSF_getPath(event.target, m_selInd);
            var m_ds = RSF_getDatasource(event.target, m_selInd);
            // Get field list
            var m_fieldList = document.getElementById('14');
            // Display selected field
            var m_dsText    = document.getElementById('41');
            m_dsText.value = m_dsPath;
            
            m_fieldList.setAttribute('ref',m_ds);
            m_fieldList.builder.rebuild();
            RSF_fieldMenulsit();
            
            var m_field = RSF_getField(event.target,m_selInd);
            m_fieldList.value = m_field;
            var m_checkBox = document.getElementById('60');
            m_checkBox.checked = true;
      }catch(e){
         alert('BindConfig2.js RSF_dsSel() '+e);
         throw e;
      }
     }
 
  /* *********************************************************************
   * Function for getting datasource path, datasource is a field path 
   * joined with string '->'.
   * *********************************************************************
   */
    function RSF_getPath(m_tree, m_selIndex)
    {
      try{
          var m_path='';
          var m_parIndex = m_tree.view.getParentIndex(m_selIndex);
          var m_tempPath;
          
          while(-1!=m_parIndex)
          {
            m_tempPath = m_tree.view.getCellText(m_parIndex ,m_tree.columns[1]);
            m_parIndex = m_tree.view.getParentIndex(m_parIndex); 
            m_path = m_tempPath +'->'+ m_path;
          }
          
          m_path = m_path.slice(0,-2);
          return m_path;
      }catch(e){
         alert('BindConfig2.js RSF_getPath() '+e);
         throw e;
      }
    }
    
  /* ********************************************************************* 
   * Function for getting table URI from tree value.
   * The returned value is often used at 'ref' attribute setting
   * *********************************************************************
   */
    function RSF_getDatasource(m_tree, m_selIndex)
    {
     try{
         var m_ds = m_tree.view.getCellValue(m_selIndex ,m_tree.columns[0]);
         
         return m_ds;
     }catch(e){
        alert('BindConfig2.js RSF_getDatasource() '+e);
        throw e;
     }
    }
    
  /* *********************************************************************
   * Function fro getting field name from tree text
   * *********************************************************************
   */  
    function RSF_getField(m_tree, m_selIndex)
    {
     try{
         var m_field = m_tree.view.getCellText(m_selIndex ,m_tree.columns[1]);
         
         return m_field;
     }catch(e){
        alert('BindConfig2.js RSF_getField() '+e);
        throw e;
     }
    }
    
  /* *********************************************************************
   * If menuitem object has a 'msubschema' attribute value, we can know
   * that this field is a subschema, namely another table, not just a fie-
   * ld. Because it is not a real field, we should let it not visible and
   * give some promption words, for example '请在这里选择字段'.
   * *********************************************************************
   */
    function RSF_fieldMenulsit()
    {
     try{
         var m_menulistPop = document.getElementById('14').childNodes[1];
         
         for(var i=0;i<m_menulistPop.childNodes.length;i++)
         {  
           if(m_menulistPop.childNodes[i].getAttribute('msubschema')!='')
           {  
              m_menulistPop.childNodes[i].setAttribute('hidden','true');
              var ChoiceF=document.getElementById("strings").getString("ChoiceF");
              m_menulistPop.childNodes[i].setAttribute('label',ChoiceF);
              //m_menulistPop.removeChild(m_menulistPop.childNodes[i]);
           }
         }
     
     }catch(e){
        alert('BindConfig2.js RSF_fieldMenulsit() '+e);
        throw e;
     }
    }
    
  /* *********************************************************************
   * Function of OK button command
   * *********************************************************************
   */
   function RSF_dsOK(event)
   {
    try{
        RSF_dsApply(event);  
        
        window.close();
        return true;
    }catch(e){
       alert('BindConfig2.js RSF_dsOK() '+e);
       throw e;
    }
   }
   
  /* *********************************************************************
   * Function of Cancel button command
   * *********************************************************************
   */
   function RSF_dsCancel(event)
   {
    try{
        var m_Doc = window.arguments[2];
        var m_obj = window.arguments[1].target;
        
        window.close();
        return true;
    
    }catch(e){
       alert('BindConfig2.js RSF_dsCancel() '+e);
       throw e;
    }
   }
   
  /* *********************************************************************
   * Function of Apply button command
   * *********************************************************************
   */
   function RSF_dsApply(event)
   {
    try{
        // Current xul document component
        var m_Doc = window.arguments[2];
        // Current element that should be config database
        var m_obj = window.arguments[1].target;
        var m_dsPath = document.getElementById('41').value;
        var m_field  = document.getElementById('14').label;
        // A regular expression
        var m_regExp = /\s+/;
        var m_fieldURI = m_field.split(m_regExp);
        
        if(document.getElementById('60').checked)
        {
            m_Doc.SetAttribute('RS_datasource',m_dsPath,m_obj);
            m_Doc.SetAttribute('RS_field',m_fieldURI[0],m_obj);    
        }
         else
         {
            m_Doc.RemoveAttribute('RS_datasource',m_obj);
            m_Doc.RemoveAttribute('RS_field',m_obj);    
         }
        
    
        return true;
    }catch(e){
       alert('BindConfig2.js RSF_dsApply() '+e);
       throw e;
    }
   }